// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	imageregistryv1 "github.com/openshift/api/imageregistry/v1"
	versioned "github.com/openshift/client-go/imageregistry/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/imageregistry/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/imageregistry/listers/imageregistry/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ImagePrunerInformer provides access to a shared informer and lister for
// ImagePruners.
type ImagePrunerInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.ImagePrunerLister
}

type imagePrunerInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewImagePrunerInformer constructs a new informer for ImagePruner type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewImagePrunerInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredImagePrunerInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredImagePrunerInformer constructs a new informer for ImagePruner type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredImagePrunerInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ImageregistryV1().ImagePruners().List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ImageregistryV1().ImagePruners().Watch(options)
			},
		},
		&imageregistryv1.ImagePruner{},
		resyncPeriod,
		indexers,
	)
}

func (f *imagePrunerInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredImagePrunerInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *imagePrunerInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&imageregistryv1.ImagePruner{}, f.defaultInformer)
}

func (f *imagePrunerInformer) Lister() v1.ImagePrunerLister {
	return v1.NewImagePrunerLister(f.Informer().GetIndexer())
}
